/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface GoogleProviderConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#access_approval_custom_endpoint GoogleProvider#access_approval_custom_endpoint}
    */
    readonly accessApprovalCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#access_context_manager_custom_endpoint GoogleProvider#access_context_manager_custom_endpoint}
    */
    readonly accessContextManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#access_token GoogleProvider#access_token}
    */
    readonly accessToken?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#active_directory_custom_endpoint GoogleProvider#active_directory_custom_endpoint}
    */
    readonly activeDirectoryCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#add_terraform_attribution_label GoogleProvider#add_terraform_attribution_label}
    */
    readonly addTerraformAttributionLabel?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#alloydb_custom_endpoint GoogleProvider#alloydb_custom_endpoint}
    */
    readonly alloydbCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#apigee_custom_endpoint GoogleProvider#apigee_custom_endpoint}
    */
    readonly apigeeCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#apikeys_custom_endpoint GoogleProvider#apikeys_custom_endpoint}
    */
    readonly apikeysCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#app_engine_custom_endpoint GoogleProvider#app_engine_custom_endpoint}
    */
    readonly appEngineCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#apphub_custom_endpoint GoogleProvider#apphub_custom_endpoint}
    */
    readonly apphubCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#artifact_registry_custom_endpoint GoogleProvider#artifact_registry_custom_endpoint}
    */
    readonly artifactRegistryCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#assured_workloads_custom_endpoint GoogleProvider#assured_workloads_custom_endpoint}
    */
    readonly assuredWorkloadsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#beyondcorp_custom_endpoint GoogleProvider#beyondcorp_custom_endpoint}
    */
    readonly beyondcorpCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#big_query_custom_endpoint GoogleProvider#big_query_custom_endpoint}
    */
    readonly bigQueryCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#biglake_custom_endpoint GoogleProvider#biglake_custom_endpoint}
    */
    readonly biglakeCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#bigquery_analytics_hub_custom_endpoint GoogleProvider#bigquery_analytics_hub_custom_endpoint}
    */
    readonly bigqueryAnalyticsHubCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#bigquery_connection_custom_endpoint GoogleProvider#bigquery_connection_custom_endpoint}
    */
    readonly bigqueryConnectionCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#bigquery_data_transfer_custom_endpoint GoogleProvider#bigquery_data_transfer_custom_endpoint}
    */
    readonly bigqueryDataTransferCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#bigquery_datapolicy_custom_endpoint GoogleProvider#bigquery_datapolicy_custom_endpoint}
    */
    readonly bigqueryDatapolicyCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#bigquery_reservation_custom_endpoint GoogleProvider#bigquery_reservation_custom_endpoint}
    */
    readonly bigqueryReservationCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#bigtable_custom_endpoint GoogleProvider#bigtable_custom_endpoint}
    */
    readonly bigtableCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#billing_custom_endpoint GoogleProvider#billing_custom_endpoint}
    */
    readonly billingCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#billing_project GoogleProvider#billing_project}
    */
    readonly billingProject?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#binary_authorization_custom_endpoint GoogleProvider#binary_authorization_custom_endpoint}
    */
    readonly binaryAuthorizationCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#blockchain_node_engine_custom_endpoint GoogleProvider#blockchain_node_engine_custom_endpoint}
    */
    readonly blockchainNodeEngineCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#certificate_manager_custom_endpoint GoogleProvider#certificate_manager_custom_endpoint}
    */
    readonly certificateManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_asset_custom_endpoint GoogleProvider#cloud_asset_custom_endpoint}
    */
    readonly cloudAssetCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_billing_custom_endpoint GoogleProvider#cloud_billing_custom_endpoint}
    */
    readonly cloudBillingCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_build_custom_endpoint GoogleProvider#cloud_build_custom_endpoint}
    */
    readonly cloudBuildCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_build_worker_pool_custom_endpoint GoogleProvider#cloud_build_worker_pool_custom_endpoint}
    */
    readonly cloudBuildWorkerPoolCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_functions_custom_endpoint GoogleProvider#cloud_functions_custom_endpoint}
    */
    readonly cloudFunctionsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_identity_custom_endpoint GoogleProvider#cloud_identity_custom_endpoint}
    */
    readonly cloudIdentityCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_ids_custom_endpoint GoogleProvider#cloud_ids_custom_endpoint}
    */
    readonly cloudIdsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_quotas_custom_endpoint GoogleProvider#cloud_quotas_custom_endpoint}
    */
    readonly cloudQuotasCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_resource_manager_custom_endpoint GoogleProvider#cloud_resource_manager_custom_endpoint}
    */
    readonly cloudResourceManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_run_custom_endpoint GoogleProvider#cloud_run_custom_endpoint}
    */
    readonly cloudRunCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_run_v2_custom_endpoint GoogleProvider#cloud_run_v2_custom_endpoint}
    */
    readonly cloudRunV2CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_scheduler_custom_endpoint GoogleProvider#cloud_scheduler_custom_endpoint}
    */
    readonly cloudSchedulerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloud_tasks_custom_endpoint GoogleProvider#cloud_tasks_custom_endpoint}
    */
    readonly cloudTasksCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloudbuildv2_custom_endpoint GoogleProvider#cloudbuildv2_custom_endpoint}
    */
    readonly cloudbuildv2CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#clouddeploy_custom_endpoint GoogleProvider#clouddeploy_custom_endpoint}
    */
    readonly clouddeployCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#clouddomains_custom_endpoint GoogleProvider#clouddomains_custom_endpoint}
    */
    readonly clouddomainsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#cloudfunctions2_custom_endpoint GoogleProvider#cloudfunctions2_custom_endpoint}
    */
    readonly cloudfunctions2CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#composer_custom_endpoint GoogleProvider#composer_custom_endpoint}
    */
    readonly composerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#compute_custom_endpoint GoogleProvider#compute_custom_endpoint}
    */
    readonly computeCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#container_analysis_custom_endpoint GoogleProvider#container_analysis_custom_endpoint}
    */
    readonly containerAnalysisCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#container_attached_custom_endpoint GoogleProvider#container_attached_custom_endpoint}
    */
    readonly containerAttachedCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#container_aws_custom_endpoint GoogleProvider#container_aws_custom_endpoint}
    */
    readonly containerAwsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#container_azure_custom_endpoint GoogleProvider#container_azure_custom_endpoint}
    */
    readonly containerAzureCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#container_custom_endpoint GoogleProvider#container_custom_endpoint}
    */
    readonly containerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#core_billing_custom_endpoint GoogleProvider#core_billing_custom_endpoint}
    */
    readonly coreBillingCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#credentials GoogleProvider#credentials}
    */
    readonly credentials?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#data_catalog_custom_endpoint GoogleProvider#data_catalog_custom_endpoint}
    */
    readonly dataCatalogCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#data_fusion_custom_endpoint GoogleProvider#data_fusion_custom_endpoint}
    */
    readonly dataFusionCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#data_loss_prevention_custom_endpoint GoogleProvider#data_loss_prevention_custom_endpoint}
    */
    readonly dataLossPreventionCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#data_pipeline_custom_endpoint GoogleProvider#data_pipeline_custom_endpoint}
    */
    readonly dataPipelineCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#database_migration_service_custom_endpoint GoogleProvider#database_migration_service_custom_endpoint}
    */
    readonly databaseMigrationServiceCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dataflow_custom_endpoint GoogleProvider#dataflow_custom_endpoint}
    */
    readonly dataflowCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dataplex_custom_endpoint GoogleProvider#dataplex_custom_endpoint}
    */
    readonly dataplexCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dataproc_custom_endpoint GoogleProvider#dataproc_custom_endpoint}
    */
    readonly dataprocCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dataproc_metastore_custom_endpoint GoogleProvider#dataproc_metastore_custom_endpoint}
    */
    readonly dataprocMetastoreCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#datastream_custom_endpoint GoogleProvider#datastream_custom_endpoint}
    */
    readonly datastreamCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#default_labels GoogleProvider#default_labels}
    */
    readonly defaultLabels?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#deployment_manager_custom_endpoint GoogleProvider#deployment_manager_custom_endpoint}
    */
    readonly deploymentManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dialogflow_custom_endpoint GoogleProvider#dialogflow_custom_endpoint}
    */
    readonly dialogflowCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dialogflow_cx_custom_endpoint GoogleProvider#dialogflow_cx_custom_endpoint}
    */
    readonly dialogflowCxCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#discovery_engine_custom_endpoint GoogleProvider#discovery_engine_custom_endpoint}
    */
    readonly discoveryEngineCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#dns_custom_endpoint GoogleProvider#dns_custom_endpoint}
    */
    readonly dnsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#document_ai_custom_endpoint GoogleProvider#document_ai_custom_endpoint}
    */
    readonly documentAiCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#document_ai_warehouse_custom_endpoint GoogleProvider#document_ai_warehouse_custom_endpoint}
    */
    readonly documentAiWarehouseCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#edgecontainer_custom_endpoint GoogleProvider#edgecontainer_custom_endpoint}
    */
    readonly edgecontainerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#edgenetwork_custom_endpoint GoogleProvider#edgenetwork_custom_endpoint}
    */
    readonly edgenetworkCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#essential_contacts_custom_endpoint GoogleProvider#essential_contacts_custom_endpoint}
    */
    readonly essentialContactsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#eventarc_custom_endpoint GoogleProvider#eventarc_custom_endpoint}
    */
    readonly eventarcCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#filestore_custom_endpoint GoogleProvider#filestore_custom_endpoint}
    */
    readonly filestoreCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#firebase_app_check_custom_endpoint GoogleProvider#firebase_app_check_custom_endpoint}
    */
    readonly firebaseAppCheckCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#firebaserules_custom_endpoint GoogleProvider#firebaserules_custom_endpoint}
    */
    readonly firebaserulesCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#firestore_custom_endpoint GoogleProvider#firestore_custom_endpoint}
    */
    readonly firestoreCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#gke_backup_custom_endpoint GoogleProvider#gke_backup_custom_endpoint}
    */
    readonly gkeBackupCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#gke_hub2_custom_endpoint GoogleProvider#gke_hub2_custom_endpoint}
    */
    readonly gkeHub2CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#gke_hub_custom_endpoint GoogleProvider#gke_hub_custom_endpoint}
    */
    readonly gkeHubCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#gkehub_feature_custom_endpoint GoogleProvider#gkehub_feature_custom_endpoint}
    */
    readonly gkehubFeatureCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#gkeonprem_custom_endpoint GoogleProvider#gkeonprem_custom_endpoint}
    */
    readonly gkeonpremCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#healthcare_custom_endpoint GoogleProvider#healthcare_custom_endpoint}
    */
    readonly healthcareCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#iam2_custom_endpoint GoogleProvider#iam2_custom_endpoint}
    */
    readonly iam2CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#iam_beta_custom_endpoint GoogleProvider#iam_beta_custom_endpoint}
    */
    readonly iamBetaCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#iam_credentials_custom_endpoint GoogleProvider#iam_credentials_custom_endpoint}
    */
    readonly iamCredentialsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#iam_custom_endpoint GoogleProvider#iam_custom_endpoint}
    */
    readonly iamCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#iam_workforce_pool_custom_endpoint GoogleProvider#iam_workforce_pool_custom_endpoint}
    */
    readonly iamWorkforcePoolCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#iap_custom_endpoint GoogleProvider#iap_custom_endpoint}
    */
    readonly iapCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#identity_platform_custom_endpoint GoogleProvider#identity_platform_custom_endpoint}
    */
    readonly identityPlatformCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#impersonate_service_account GoogleProvider#impersonate_service_account}
    */
    readonly impersonateServiceAccount?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#impersonate_service_account_delegates GoogleProvider#impersonate_service_account_delegates}
    */
    readonly impersonateServiceAccountDelegates?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#integration_connectors_custom_endpoint GoogleProvider#integration_connectors_custom_endpoint}
    */
    readonly integrationConnectorsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#integrations_custom_endpoint GoogleProvider#integrations_custom_endpoint}
    */
    readonly integrationsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#kms_custom_endpoint GoogleProvider#kms_custom_endpoint}
    */
    readonly kmsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#logging_custom_endpoint GoogleProvider#logging_custom_endpoint}
    */
    readonly loggingCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#looker_custom_endpoint GoogleProvider#looker_custom_endpoint}
    */
    readonly lookerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#memcache_custom_endpoint GoogleProvider#memcache_custom_endpoint}
    */
    readonly memcacheCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#migration_center_custom_endpoint GoogleProvider#migration_center_custom_endpoint}
    */
    readonly migrationCenterCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#ml_engine_custom_endpoint GoogleProvider#ml_engine_custom_endpoint}
    */
    readonly mlEngineCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#monitoring_custom_endpoint GoogleProvider#monitoring_custom_endpoint}
    */
    readonly monitoringCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#netapp_custom_endpoint GoogleProvider#netapp_custom_endpoint}
    */
    readonly netappCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#network_connectivity_custom_endpoint GoogleProvider#network_connectivity_custom_endpoint}
    */
    readonly networkConnectivityCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#network_management_custom_endpoint GoogleProvider#network_management_custom_endpoint}
    */
    readonly networkManagementCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#network_security_custom_endpoint GoogleProvider#network_security_custom_endpoint}
    */
    readonly networkSecurityCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#network_services_custom_endpoint GoogleProvider#network_services_custom_endpoint}
    */
    readonly networkServicesCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#notebooks_custom_endpoint GoogleProvider#notebooks_custom_endpoint}
    */
    readonly notebooksCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#org_policy_custom_endpoint GoogleProvider#org_policy_custom_endpoint}
    */
    readonly orgPolicyCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#os_config_custom_endpoint GoogleProvider#os_config_custom_endpoint}
    */
    readonly osConfigCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#os_login_custom_endpoint GoogleProvider#os_login_custom_endpoint}
    */
    readonly osLoginCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#privateca_custom_endpoint GoogleProvider#privateca_custom_endpoint}
    */
    readonly privatecaCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#privileged_access_manager_custom_endpoint GoogleProvider#privileged_access_manager_custom_endpoint}
    */
    readonly privilegedAccessManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#project GoogleProvider#project}
    */
    readonly project?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#public_ca_custom_endpoint GoogleProvider#public_ca_custom_endpoint}
    */
    readonly publicCaCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#pubsub_custom_endpoint GoogleProvider#pubsub_custom_endpoint}
    */
    readonly pubsubCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#pubsub_lite_custom_endpoint GoogleProvider#pubsub_lite_custom_endpoint}
    */
    readonly pubsubLiteCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#recaptcha_enterprise_custom_endpoint GoogleProvider#recaptcha_enterprise_custom_endpoint}
    */
    readonly recaptchaEnterpriseCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#redis_custom_endpoint GoogleProvider#redis_custom_endpoint}
    */
    readonly redisCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#region GoogleProvider#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#request_reason GoogleProvider#request_reason}
    */
    readonly requestReason?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#request_timeout GoogleProvider#request_timeout}
    */
    readonly requestTimeout?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#resource_manager_custom_endpoint GoogleProvider#resource_manager_custom_endpoint}
    */
    readonly resourceManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#resource_manager_v3_custom_endpoint GoogleProvider#resource_manager_v3_custom_endpoint}
    */
    readonly resourceManagerV3CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#scopes GoogleProvider#scopes}
    */
    readonly scopes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#secret_manager_custom_endpoint GoogleProvider#secret_manager_custom_endpoint}
    */
    readonly secretManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#secure_source_manager_custom_endpoint GoogleProvider#secure_source_manager_custom_endpoint}
    */
    readonly secureSourceManagerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#security_center_custom_endpoint GoogleProvider#security_center_custom_endpoint}
    */
    readonly securityCenterCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#security_center_management_custom_endpoint GoogleProvider#security_center_management_custom_endpoint}
    */
    readonly securityCenterManagementCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#security_center_v2_custom_endpoint GoogleProvider#security_center_v2_custom_endpoint}
    */
    readonly securityCenterV2CustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#securityposture_custom_endpoint GoogleProvider#securityposture_custom_endpoint}
    */
    readonly securitypostureCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#service_management_custom_endpoint GoogleProvider#service_management_custom_endpoint}
    */
    readonly serviceManagementCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#service_networking_custom_endpoint GoogleProvider#service_networking_custom_endpoint}
    */
    readonly serviceNetworkingCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#service_usage_custom_endpoint GoogleProvider#service_usage_custom_endpoint}
    */
    readonly serviceUsageCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#site_verification_custom_endpoint GoogleProvider#site_verification_custom_endpoint}
    */
    readonly siteVerificationCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#source_repo_custom_endpoint GoogleProvider#source_repo_custom_endpoint}
    */
    readonly sourceRepoCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#spanner_custom_endpoint GoogleProvider#spanner_custom_endpoint}
    */
    readonly spannerCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#sql_custom_endpoint GoogleProvider#sql_custom_endpoint}
    */
    readonly sqlCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#storage_custom_endpoint GoogleProvider#storage_custom_endpoint}
    */
    readonly storageCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#storage_insights_custom_endpoint GoogleProvider#storage_insights_custom_endpoint}
    */
    readonly storageInsightsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#storage_transfer_custom_endpoint GoogleProvider#storage_transfer_custom_endpoint}
    */
    readonly storageTransferCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#tags_custom_endpoint GoogleProvider#tags_custom_endpoint}
    */
    readonly tagsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#tags_location_custom_endpoint GoogleProvider#tags_location_custom_endpoint}
    */
    readonly tagsLocationCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#terraform_attribution_label_addition_strategy GoogleProvider#terraform_attribution_label_addition_strategy}
    */
    readonly terraformAttributionLabelAdditionStrategy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#tpu_custom_endpoint GoogleProvider#tpu_custom_endpoint}
    */
    readonly tpuCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#universe_domain GoogleProvider#universe_domain}
    */
    readonly universeDomain?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#user_project_override GoogleProvider#user_project_override}
    */
    readonly userProjectOverride?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#vertex_ai_custom_endpoint GoogleProvider#vertex_ai_custom_endpoint}
    */
    readonly vertexAiCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#vmwareengine_custom_endpoint GoogleProvider#vmwareengine_custom_endpoint}
    */
    readonly vmwareengineCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#vpc_access_custom_endpoint GoogleProvider#vpc_access_custom_endpoint}
    */
    readonly vpcAccessCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#workbench_custom_endpoint GoogleProvider#workbench_custom_endpoint}
    */
    readonly workbenchCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#workflows_custom_endpoint GoogleProvider#workflows_custom_endpoint}
    */
    readonly workflowsCustomEndpoint?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#zone GoogleProvider#zone}
    */
    readonly zone?: string;
    /**
    * Alias name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#alias GoogleProvider#alias}
    */
    readonly alias?: string;
    /**
    * batching block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#batching GoogleProvider#batching}
    */
    readonly batching?: GoogleProviderBatching;
}
export interface GoogleProviderBatching {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#enable_batching GoogleProvider#enable_batching}
    */
    readonly enableBatching?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#send_after GoogleProvider#send_after}
    */
    readonly sendAfter?: string;
}
export declare function googleProviderBatchingToTerraform(struct?: GoogleProviderBatching): any;
export declare function googleProviderBatchingToHclTerraform(struct?: GoogleProviderBatching): any;
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs google}
*/
export declare class GoogleProvider extends cdktf.TerraformProvider {
    static readonly tfResourceType = "google";
    /**
    * Generates CDKTF code for importing a GoogleProvider resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the GoogleProvider to import
    * @param importFromId The id of the existing GoogleProvider that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the GoogleProvider to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs google} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options GoogleProviderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: GoogleProviderConfig);
    private _accessApprovalCustomEndpoint?;
    get accessApprovalCustomEndpoint(): string | undefined;
    set accessApprovalCustomEndpoint(value: string | undefined);
    resetAccessApprovalCustomEndpoint(): void;
    get accessApprovalCustomEndpointInput(): string | undefined;
    private _accessContextManagerCustomEndpoint?;
    get accessContextManagerCustomEndpoint(): string | undefined;
    set accessContextManagerCustomEndpoint(value: string | undefined);
    resetAccessContextManagerCustomEndpoint(): void;
    get accessContextManagerCustomEndpointInput(): string | undefined;
    private _accessToken?;
    get accessToken(): string | undefined;
    set accessToken(value: string | undefined);
    resetAccessToken(): void;
    get accessTokenInput(): string | undefined;
    private _activeDirectoryCustomEndpoint?;
    get activeDirectoryCustomEndpoint(): string | undefined;
    set activeDirectoryCustomEndpoint(value: string | undefined);
    resetActiveDirectoryCustomEndpoint(): void;
    get activeDirectoryCustomEndpointInput(): string | undefined;
    private _addTerraformAttributionLabel?;
    get addTerraformAttributionLabel(): boolean | cdktf.IResolvable | undefined;
    set addTerraformAttributionLabel(value: boolean | cdktf.IResolvable | undefined);
    resetAddTerraformAttributionLabel(): void;
    get addTerraformAttributionLabelInput(): boolean | cdktf.IResolvable | undefined;
    private _alloydbCustomEndpoint?;
    get alloydbCustomEndpoint(): string | undefined;
    set alloydbCustomEndpoint(value: string | undefined);
    resetAlloydbCustomEndpoint(): void;
    get alloydbCustomEndpointInput(): string | undefined;
    private _apigeeCustomEndpoint?;
    get apigeeCustomEndpoint(): string | undefined;
    set apigeeCustomEndpoint(value: string | undefined);
    resetApigeeCustomEndpoint(): void;
    get apigeeCustomEndpointInput(): string | undefined;
    private _apikeysCustomEndpoint?;
    get apikeysCustomEndpoint(): string | undefined;
    set apikeysCustomEndpoint(value: string | undefined);
    resetApikeysCustomEndpoint(): void;
    get apikeysCustomEndpointInput(): string | undefined;
    private _appEngineCustomEndpoint?;
    get appEngineCustomEndpoint(): string | undefined;
    set appEngineCustomEndpoint(value: string | undefined);
    resetAppEngineCustomEndpoint(): void;
    get appEngineCustomEndpointInput(): string | undefined;
    private _apphubCustomEndpoint?;
    get apphubCustomEndpoint(): string | undefined;
    set apphubCustomEndpoint(value: string | undefined);
    resetApphubCustomEndpoint(): void;
    get apphubCustomEndpointInput(): string | undefined;
    private _artifactRegistryCustomEndpoint?;
    get artifactRegistryCustomEndpoint(): string | undefined;
    set artifactRegistryCustomEndpoint(value: string | undefined);
    resetArtifactRegistryCustomEndpoint(): void;
    get artifactRegistryCustomEndpointInput(): string | undefined;
    private _assuredWorkloadsCustomEndpoint?;
    get assuredWorkloadsCustomEndpoint(): string | undefined;
    set assuredWorkloadsCustomEndpoint(value: string | undefined);
    resetAssuredWorkloadsCustomEndpoint(): void;
    get assuredWorkloadsCustomEndpointInput(): string | undefined;
    private _beyondcorpCustomEndpoint?;
    get beyondcorpCustomEndpoint(): string | undefined;
    set beyondcorpCustomEndpoint(value: string | undefined);
    resetBeyondcorpCustomEndpoint(): void;
    get beyondcorpCustomEndpointInput(): string | undefined;
    private _bigQueryCustomEndpoint?;
    get bigQueryCustomEndpoint(): string | undefined;
    set bigQueryCustomEndpoint(value: string | undefined);
    resetBigQueryCustomEndpoint(): void;
    get bigQueryCustomEndpointInput(): string | undefined;
    private _biglakeCustomEndpoint?;
    get biglakeCustomEndpoint(): string | undefined;
    set biglakeCustomEndpoint(value: string | undefined);
    resetBiglakeCustomEndpoint(): void;
    get biglakeCustomEndpointInput(): string | undefined;
    private _bigqueryAnalyticsHubCustomEndpoint?;
    get bigqueryAnalyticsHubCustomEndpoint(): string | undefined;
    set bigqueryAnalyticsHubCustomEndpoint(value: string | undefined);
    resetBigqueryAnalyticsHubCustomEndpoint(): void;
    get bigqueryAnalyticsHubCustomEndpointInput(): string | undefined;
    private _bigqueryConnectionCustomEndpoint?;
    get bigqueryConnectionCustomEndpoint(): string | undefined;
    set bigqueryConnectionCustomEndpoint(value: string | undefined);
    resetBigqueryConnectionCustomEndpoint(): void;
    get bigqueryConnectionCustomEndpointInput(): string | undefined;
    private _bigqueryDataTransferCustomEndpoint?;
    get bigqueryDataTransferCustomEndpoint(): string | undefined;
    set bigqueryDataTransferCustomEndpoint(value: string | undefined);
    resetBigqueryDataTransferCustomEndpoint(): void;
    get bigqueryDataTransferCustomEndpointInput(): string | undefined;
    private _bigqueryDatapolicyCustomEndpoint?;
    get bigqueryDatapolicyCustomEndpoint(): string | undefined;
    set bigqueryDatapolicyCustomEndpoint(value: string | undefined);
    resetBigqueryDatapolicyCustomEndpoint(): void;
    get bigqueryDatapolicyCustomEndpointInput(): string | undefined;
    private _bigqueryReservationCustomEndpoint?;
    get bigqueryReservationCustomEndpoint(): string | undefined;
    set bigqueryReservationCustomEndpoint(value: string | undefined);
    resetBigqueryReservationCustomEndpoint(): void;
    get bigqueryReservationCustomEndpointInput(): string | undefined;
    private _bigtableCustomEndpoint?;
    get bigtableCustomEndpoint(): string | undefined;
    set bigtableCustomEndpoint(value: string | undefined);
    resetBigtableCustomEndpoint(): void;
    get bigtableCustomEndpointInput(): string | undefined;
    private _billingCustomEndpoint?;
    get billingCustomEndpoint(): string | undefined;
    set billingCustomEndpoint(value: string | undefined);
    resetBillingCustomEndpoint(): void;
    get billingCustomEndpointInput(): string | undefined;
    private _billingProject?;
    get billingProject(): string | undefined;
    set billingProject(value: string | undefined);
    resetBillingProject(): void;
    get billingProjectInput(): string | undefined;
    private _binaryAuthorizationCustomEndpoint?;
    get binaryAuthorizationCustomEndpoint(): string | undefined;
    set binaryAuthorizationCustomEndpoint(value: string | undefined);
    resetBinaryAuthorizationCustomEndpoint(): void;
    get binaryAuthorizationCustomEndpointInput(): string | undefined;
    private _blockchainNodeEngineCustomEndpoint?;
    get blockchainNodeEngineCustomEndpoint(): string | undefined;
    set blockchainNodeEngineCustomEndpoint(value: string | undefined);
    resetBlockchainNodeEngineCustomEndpoint(): void;
    get blockchainNodeEngineCustomEndpointInput(): string | undefined;
    private _certificateManagerCustomEndpoint?;
    get certificateManagerCustomEndpoint(): string | undefined;
    set certificateManagerCustomEndpoint(value: string | undefined);
    resetCertificateManagerCustomEndpoint(): void;
    get certificateManagerCustomEndpointInput(): string | undefined;
    private _cloudAssetCustomEndpoint?;
    get cloudAssetCustomEndpoint(): string | undefined;
    set cloudAssetCustomEndpoint(value: string | undefined);
    resetCloudAssetCustomEndpoint(): void;
    get cloudAssetCustomEndpointInput(): string | undefined;
    private _cloudBillingCustomEndpoint?;
    get cloudBillingCustomEndpoint(): string | undefined;
    set cloudBillingCustomEndpoint(value: string | undefined);
    resetCloudBillingCustomEndpoint(): void;
    get cloudBillingCustomEndpointInput(): string | undefined;
    private _cloudBuildCustomEndpoint?;
    get cloudBuildCustomEndpoint(): string | undefined;
    set cloudBuildCustomEndpoint(value: string | undefined);
    resetCloudBuildCustomEndpoint(): void;
    get cloudBuildCustomEndpointInput(): string | undefined;
    private _cloudBuildWorkerPoolCustomEndpoint?;
    get cloudBuildWorkerPoolCustomEndpoint(): string | undefined;
    set cloudBuildWorkerPoolCustomEndpoint(value: string | undefined);
    resetCloudBuildWorkerPoolCustomEndpoint(): void;
    get cloudBuildWorkerPoolCustomEndpointInput(): string | undefined;
    private _cloudFunctionsCustomEndpoint?;
    get cloudFunctionsCustomEndpoint(): string | undefined;
    set cloudFunctionsCustomEndpoint(value: string | undefined);
    resetCloudFunctionsCustomEndpoint(): void;
    get cloudFunctionsCustomEndpointInput(): string | undefined;
    private _cloudIdentityCustomEndpoint?;
    get cloudIdentityCustomEndpoint(): string | undefined;
    set cloudIdentityCustomEndpoint(value: string | undefined);
    resetCloudIdentityCustomEndpoint(): void;
    get cloudIdentityCustomEndpointInput(): string | undefined;
    private _cloudIdsCustomEndpoint?;
    get cloudIdsCustomEndpoint(): string | undefined;
    set cloudIdsCustomEndpoint(value: string | undefined);
    resetCloudIdsCustomEndpoint(): void;
    get cloudIdsCustomEndpointInput(): string | undefined;
    private _cloudQuotasCustomEndpoint?;
    get cloudQuotasCustomEndpoint(): string | undefined;
    set cloudQuotasCustomEndpoint(value: string | undefined);
    resetCloudQuotasCustomEndpoint(): void;
    get cloudQuotasCustomEndpointInput(): string | undefined;
    private _cloudResourceManagerCustomEndpoint?;
    get cloudResourceManagerCustomEndpoint(): string | undefined;
    set cloudResourceManagerCustomEndpoint(value: string | undefined);
    resetCloudResourceManagerCustomEndpoint(): void;
    get cloudResourceManagerCustomEndpointInput(): string | undefined;
    private _cloudRunCustomEndpoint?;
    get cloudRunCustomEndpoint(): string | undefined;
    set cloudRunCustomEndpoint(value: string | undefined);
    resetCloudRunCustomEndpoint(): void;
    get cloudRunCustomEndpointInput(): string | undefined;
    private _cloudRunV2CustomEndpoint?;
    get cloudRunV2CustomEndpoint(): string | undefined;
    set cloudRunV2CustomEndpoint(value: string | undefined);
    resetCloudRunV2CustomEndpoint(): void;
    get cloudRunV2CustomEndpointInput(): string | undefined;
    private _cloudSchedulerCustomEndpoint?;
    get cloudSchedulerCustomEndpoint(): string | undefined;
    set cloudSchedulerCustomEndpoint(value: string | undefined);
    resetCloudSchedulerCustomEndpoint(): void;
    get cloudSchedulerCustomEndpointInput(): string | undefined;
    private _cloudTasksCustomEndpoint?;
    get cloudTasksCustomEndpoint(): string | undefined;
    set cloudTasksCustomEndpoint(value: string | undefined);
    resetCloudTasksCustomEndpoint(): void;
    get cloudTasksCustomEndpointInput(): string | undefined;
    private _cloudbuildv2CustomEndpoint?;
    get cloudbuildv2CustomEndpoint(): string | undefined;
    set cloudbuildv2CustomEndpoint(value: string | undefined);
    resetCloudbuildv2CustomEndpoint(): void;
    get cloudbuildv2CustomEndpointInput(): string | undefined;
    private _clouddeployCustomEndpoint?;
    get clouddeployCustomEndpoint(): string | undefined;
    set clouddeployCustomEndpoint(value: string | undefined);
    resetClouddeployCustomEndpoint(): void;
    get clouddeployCustomEndpointInput(): string | undefined;
    private _clouddomainsCustomEndpoint?;
    get clouddomainsCustomEndpoint(): string | undefined;
    set clouddomainsCustomEndpoint(value: string | undefined);
    resetClouddomainsCustomEndpoint(): void;
    get clouddomainsCustomEndpointInput(): string | undefined;
    private _cloudfunctions2CustomEndpoint?;
    get cloudfunctions2CustomEndpoint(): string | undefined;
    set cloudfunctions2CustomEndpoint(value: string | undefined);
    resetCloudfunctions2CustomEndpoint(): void;
    get cloudfunctions2CustomEndpointInput(): string | undefined;
    private _composerCustomEndpoint?;
    get composerCustomEndpoint(): string | undefined;
    set composerCustomEndpoint(value: string | undefined);
    resetComposerCustomEndpoint(): void;
    get composerCustomEndpointInput(): string | undefined;
    private _computeCustomEndpoint?;
    get computeCustomEndpoint(): string | undefined;
    set computeCustomEndpoint(value: string | undefined);
    resetComputeCustomEndpoint(): void;
    get computeCustomEndpointInput(): string | undefined;
    private _containerAnalysisCustomEndpoint?;
    get containerAnalysisCustomEndpoint(): string | undefined;
    set containerAnalysisCustomEndpoint(value: string | undefined);
    resetContainerAnalysisCustomEndpoint(): void;
    get containerAnalysisCustomEndpointInput(): string | undefined;
    private _containerAttachedCustomEndpoint?;
    get containerAttachedCustomEndpoint(): string | undefined;
    set containerAttachedCustomEndpoint(value: string | undefined);
    resetContainerAttachedCustomEndpoint(): void;
    get containerAttachedCustomEndpointInput(): string | undefined;
    private _containerAwsCustomEndpoint?;
    get containerAwsCustomEndpoint(): string | undefined;
    set containerAwsCustomEndpoint(value: string | undefined);
    resetContainerAwsCustomEndpoint(): void;
    get containerAwsCustomEndpointInput(): string | undefined;
    private _containerAzureCustomEndpoint?;
    get containerAzureCustomEndpoint(): string | undefined;
    set containerAzureCustomEndpoint(value: string | undefined);
    resetContainerAzureCustomEndpoint(): void;
    get containerAzureCustomEndpointInput(): string | undefined;
    private _containerCustomEndpoint?;
    get containerCustomEndpoint(): string | undefined;
    set containerCustomEndpoint(value: string | undefined);
    resetContainerCustomEndpoint(): void;
    get containerCustomEndpointInput(): string | undefined;
    private _coreBillingCustomEndpoint?;
    get coreBillingCustomEndpoint(): string | undefined;
    set coreBillingCustomEndpoint(value: string | undefined);
    resetCoreBillingCustomEndpoint(): void;
    get coreBillingCustomEndpointInput(): string | undefined;
    private _credentials?;
    get credentials(): string | undefined;
    set credentials(value: string | undefined);
    resetCredentials(): void;
    get credentialsInput(): string | undefined;
    private _dataCatalogCustomEndpoint?;
    get dataCatalogCustomEndpoint(): string | undefined;
    set dataCatalogCustomEndpoint(value: string | undefined);
    resetDataCatalogCustomEndpoint(): void;
    get dataCatalogCustomEndpointInput(): string | undefined;
    private _dataFusionCustomEndpoint?;
    get dataFusionCustomEndpoint(): string | undefined;
    set dataFusionCustomEndpoint(value: string | undefined);
    resetDataFusionCustomEndpoint(): void;
    get dataFusionCustomEndpointInput(): string | undefined;
    private _dataLossPreventionCustomEndpoint?;
    get dataLossPreventionCustomEndpoint(): string | undefined;
    set dataLossPreventionCustomEndpoint(value: string | undefined);
    resetDataLossPreventionCustomEndpoint(): void;
    get dataLossPreventionCustomEndpointInput(): string | undefined;
    private _dataPipelineCustomEndpoint?;
    get dataPipelineCustomEndpoint(): string | undefined;
    set dataPipelineCustomEndpoint(value: string | undefined);
    resetDataPipelineCustomEndpoint(): void;
    get dataPipelineCustomEndpointInput(): string | undefined;
    private _databaseMigrationServiceCustomEndpoint?;
    get databaseMigrationServiceCustomEndpoint(): string | undefined;
    set databaseMigrationServiceCustomEndpoint(value: string | undefined);
    resetDatabaseMigrationServiceCustomEndpoint(): void;
    get databaseMigrationServiceCustomEndpointInput(): string | undefined;
    private _dataflowCustomEndpoint?;
    get dataflowCustomEndpoint(): string | undefined;
    set dataflowCustomEndpoint(value: string | undefined);
    resetDataflowCustomEndpoint(): void;
    get dataflowCustomEndpointInput(): string | undefined;
    private _dataplexCustomEndpoint?;
    get dataplexCustomEndpoint(): string | undefined;
    set dataplexCustomEndpoint(value: string | undefined);
    resetDataplexCustomEndpoint(): void;
    get dataplexCustomEndpointInput(): string | undefined;
    private _dataprocCustomEndpoint?;
    get dataprocCustomEndpoint(): string | undefined;
    set dataprocCustomEndpoint(value: string | undefined);
    resetDataprocCustomEndpoint(): void;
    get dataprocCustomEndpointInput(): string | undefined;
    private _dataprocMetastoreCustomEndpoint?;
    get dataprocMetastoreCustomEndpoint(): string | undefined;
    set dataprocMetastoreCustomEndpoint(value: string | undefined);
    resetDataprocMetastoreCustomEndpoint(): void;
    get dataprocMetastoreCustomEndpointInput(): string | undefined;
    private _datastreamCustomEndpoint?;
    get datastreamCustomEndpoint(): string | undefined;
    set datastreamCustomEndpoint(value: string | undefined);
    resetDatastreamCustomEndpoint(): void;
    get datastreamCustomEndpointInput(): string | undefined;
    private _defaultLabels?;
    get defaultLabels(): {
        [key: string]: string;
    } | undefined;
    set defaultLabels(value: {
        [key: string]: string;
    } | undefined);
    resetDefaultLabels(): void;
    get defaultLabelsInput(): {
        [key: string]: string;
    } | undefined;
    private _deploymentManagerCustomEndpoint?;
    get deploymentManagerCustomEndpoint(): string | undefined;
    set deploymentManagerCustomEndpoint(value: string | undefined);
    resetDeploymentManagerCustomEndpoint(): void;
    get deploymentManagerCustomEndpointInput(): string | undefined;
    private _dialogflowCustomEndpoint?;
    get dialogflowCustomEndpoint(): string | undefined;
    set dialogflowCustomEndpoint(value: string | undefined);
    resetDialogflowCustomEndpoint(): void;
    get dialogflowCustomEndpointInput(): string | undefined;
    private _dialogflowCxCustomEndpoint?;
    get dialogflowCxCustomEndpoint(): string | undefined;
    set dialogflowCxCustomEndpoint(value: string | undefined);
    resetDialogflowCxCustomEndpoint(): void;
    get dialogflowCxCustomEndpointInput(): string | undefined;
    private _discoveryEngineCustomEndpoint?;
    get discoveryEngineCustomEndpoint(): string | undefined;
    set discoveryEngineCustomEndpoint(value: string | undefined);
    resetDiscoveryEngineCustomEndpoint(): void;
    get discoveryEngineCustomEndpointInput(): string | undefined;
    private _dnsCustomEndpoint?;
    get dnsCustomEndpoint(): string | undefined;
    set dnsCustomEndpoint(value: string | undefined);
    resetDnsCustomEndpoint(): void;
    get dnsCustomEndpointInput(): string | undefined;
    private _documentAiCustomEndpoint?;
    get documentAiCustomEndpoint(): string | undefined;
    set documentAiCustomEndpoint(value: string | undefined);
    resetDocumentAiCustomEndpoint(): void;
    get documentAiCustomEndpointInput(): string | undefined;
    private _documentAiWarehouseCustomEndpoint?;
    get documentAiWarehouseCustomEndpoint(): string | undefined;
    set documentAiWarehouseCustomEndpoint(value: string | undefined);
    resetDocumentAiWarehouseCustomEndpoint(): void;
    get documentAiWarehouseCustomEndpointInput(): string | undefined;
    private _edgecontainerCustomEndpoint?;
    get edgecontainerCustomEndpoint(): string | undefined;
    set edgecontainerCustomEndpoint(value: string | undefined);
    resetEdgecontainerCustomEndpoint(): void;
    get edgecontainerCustomEndpointInput(): string | undefined;
    private _edgenetworkCustomEndpoint?;
    get edgenetworkCustomEndpoint(): string | undefined;
    set edgenetworkCustomEndpoint(value: string | undefined);
    resetEdgenetworkCustomEndpoint(): void;
    get edgenetworkCustomEndpointInput(): string | undefined;
    private _essentialContactsCustomEndpoint?;
    get essentialContactsCustomEndpoint(): string | undefined;
    set essentialContactsCustomEndpoint(value: string | undefined);
    resetEssentialContactsCustomEndpoint(): void;
    get essentialContactsCustomEndpointInput(): string | undefined;
    private _eventarcCustomEndpoint?;
    get eventarcCustomEndpoint(): string | undefined;
    set eventarcCustomEndpoint(value: string | undefined);
    resetEventarcCustomEndpoint(): void;
    get eventarcCustomEndpointInput(): string | undefined;
    private _filestoreCustomEndpoint?;
    get filestoreCustomEndpoint(): string | undefined;
    set filestoreCustomEndpoint(value: string | undefined);
    resetFilestoreCustomEndpoint(): void;
    get filestoreCustomEndpointInput(): string | undefined;
    private _firebaseAppCheckCustomEndpoint?;
    get firebaseAppCheckCustomEndpoint(): string | undefined;
    set firebaseAppCheckCustomEndpoint(value: string | undefined);
    resetFirebaseAppCheckCustomEndpoint(): void;
    get firebaseAppCheckCustomEndpointInput(): string | undefined;
    private _firebaserulesCustomEndpoint?;
    get firebaserulesCustomEndpoint(): string | undefined;
    set firebaserulesCustomEndpoint(value: string | undefined);
    resetFirebaserulesCustomEndpoint(): void;
    get firebaserulesCustomEndpointInput(): string | undefined;
    private _firestoreCustomEndpoint?;
    get firestoreCustomEndpoint(): string | undefined;
    set firestoreCustomEndpoint(value: string | undefined);
    resetFirestoreCustomEndpoint(): void;
    get firestoreCustomEndpointInput(): string | undefined;
    private _gkeBackupCustomEndpoint?;
    get gkeBackupCustomEndpoint(): string | undefined;
    set gkeBackupCustomEndpoint(value: string | undefined);
    resetGkeBackupCustomEndpoint(): void;
    get gkeBackupCustomEndpointInput(): string | undefined;
    private _gkeHub2CustomEndpoint?;
    get gkeHub2CustomEndpoint(): string | undefined;
    set gkeHub2CustomEndpoint(value: string | undefined);
    resetGkeHub2CustomEndpoint(): void;
    get gkeHub2CustomEndpointInput(): string | undefined;
    private _gkeHubCustomEndpoint?;
    get gkeHubCustomEndpoint(): string | undefined;
    set gkeHubCustomEndpoint(value: string | undefined);
    resetGkeHubCustomEndpoint(): void;
    get gkeHubCustomEndpointInput(): string | undefined;
    private _gkehubFeatureCustomEndpoint?;
    get gkehubFeatureCustomEndpoint(): string | undefined;
    set gkehubFeatureCustomEndpoint(value: string | undefined);
    resetGkehubFeatureCustomEndpoint(): void;
    get gkehubFeatureCustomEndpointInput(): string | undefined;
    private _gkeonpremCustomEndpoint?;
    get gkeonpremCustomEndpoint(): string | undefined;
    set gkeonpremCustomEndpoint(value: string | undefined);
    resetGkeonpremCustomEndpoint(): void;
    get gkeonpremCustomEndpointInput(): string | undefined;
    private _healthcareCustomEndpoint?;
    get healthcareCustomEndpoint(): string | undefined;
    set healthcareCustomEndpoint(value: string | undefined);
    resetHealthcareCustomEndpoint(): void;
    get healthcareCustomEndpointInput(): string | undefined;
    private _iam2CustomEndpoint?;
    get iam2CustomEndpoint(): string | undefined;
    set iam2CustomEndpoint(value: string | undefined);
    resetIam2CustomEndpoint(): void;
    get iam2CustomEndpointInput(): string | undefined;
    private _iamBetaCustomEndpoint?;
    get iamBetaCustomEndpoint(): string | undefined;
    set iamBetaCustomEndpoint(value: string | undefined);
    resetIamBetaCustomEndpoint(): void;
    get iamBetaCustomEndpointInput(): string | undefined;
    private _iamCredentialsCustomEndpoint?;
    get iamCredentialsCustomEndpoint(): string | undefined;
    set iamCredentialsCustomEndpoint(value: string | undefined);
    resetIamCredentialsCustomEndpoint(): void;
    get iamCredentialsCustomEndpointInput(): string | undefined;
    private _iamCustomEndpoint?;
    get iamCustomEndpoint(): string | undefined;
    set iamCustomEndpoint(value: string | undefined);
    resetIamCustomEndpoint(): void;
    get iamCustomEndpointInput(): string | undefined;
    private _iamWorkforcePoolCustomEndpoint?;
    get iamWorkforcePoolCustomEndpoint(): string | undefined;
    set iamWorkforcePoolCustomEndpoint(value: string | undefined);
    resetIamWorkforcePoolCustomEndpoint(): void;
    get iamWorkforcePoolCustomEndpointInput(): string | undefined;
    private _iapCustomEndpoint?;
    get iapCustomEndpoint(): string | undefined;
    set iapCustomEndpoint(value: string | undefined);
    resetIapCustomEndpoint(): void;
    get iapCustomEndpointInput(): string | undefined;
    private _identityPlatformCustomEndpoint?;
    get identityPlatformCustomEndpoint(): string | undefined;
    set identityPlatformCustomEndpoint(value: string | undefined);
    resetIdentityPlatformCustomEndpoint(): void;
    get identityPlatformCustomEndpointInput(): string | undefined;
    private _impersonateServiceAccount?;
    get impersonateServiceAccount(): string | undefined;
    set impersonateServiceAccount(value: string | undefined);
    resetImpersonateServiceAccount(): void;
    get impersonateServiceAccountInput(): string | undefined;
    private _impersonateServiceAccountDelegates?;
    get impersonateServiceAccountDelegates(): string[] | undefined;
    set impersonateServiceAccountDelegates(value: string[] | undefined);
    resetImpersonateServiceAccountDelegates(): void;
    get impersonateServiceAccountDelegatesInput(): string[] | undefined;
    private _integrationConnectorsCustomEndpoint?;
    get integrationConnectorsCustomEndpoint(): string | undefined;
    set integrationConnectorsCustomEndpoint(value: string | undefined);
    resetIntegrationConnectorsCustomEndpoint(): void;
    get integrationConnectorsCustomEndpointInput(): string | undefined;
    private _integrationsCustomEndpoint?;
    get integrationsCustomEndpoint(): string | undefined;
    set integrationsCustomEndpoint(value: string | undefined);
    resetIntegrationsCustomEndpoint(): void;
    get integrationsCustomEndpointInput(): string | undefined;
    private _kmsCustomEndpoint?;
    get kmsCustomEndpoint(): string | undefined;
    set kmsCustomEndpoint(value: string | undefined);
    resetKmsCustomEndpoint(): void;
    get kmsCustomEndpointInput(): string | undefined;
    private _loggingCustomEndpoint?;
    get loggingCustomEndpoint(): string | undefined;
    set loggingCustomEndpoint(value: string | undefined);
    resetLoggingCustomEndpoint(): void;
    get loggingCustomEndpointInput(): string | undefined;
    private _lookerCustomEndpoint?;
    get lookerCustomEndpoint(): string | undefined;
    set lookerCustomEndpoint(value: string | undefined);
    resetLookerCustomEndpoint(): void;
    get lookerCustomEndpointInput(): string | undefined;
    private _memcacheCustomEndpoint?;
    get memcacheCustomEndpoint(): string | undefined;
    set memcacheCustomEndpoint(value: string | undefined);
    resetMemcacheCustomEndpoint(): void;
    get memcacheCustomEndpointInput(): string | undefined;
    private _migrationCenterCustomEndpoint?;
    get migrationCenterCustomEndpoint(): string | undefined;
    set migrationCenterCustomEndpoint(value: string | undefined);
    resetMigrationCenterCustomEndpoint(): void;
    get migrationCenterCustomEndpointInput(): string | undefined;
    private _mlEngineCustomEndpoint?;
    get mlEngineCustomEndpoint(): string | undefined;
    set mlEngineCustomEndpoint(value: string | undefined);
    resetMlEngineCustomEndpoint(): void;
    get mlEngineCustomEndpointInput(): string | undefined;
    private _monitoringCustomEndpoint?;
    get monitoringCustomEndpoint(): string | undefined;
    set monitoringCustomEndpoint(value: string | undefined);
    resetMonitoringCustomEndpoint(): void;
    get monitoringCustomEndpointInput(): string | undefined;
    private _netappCustomEndpoint?;
    get netappCustomEndpoint(): string | undefined;
    set netappCustomEndpoint(value: string | undefined);
    resetNetappCustomEndpoint(): void;
    get netappCustomEndpointInput(): string | undefined;
    private _networkConnectivityCustomEndpoint?;
    get networkConnectivityCustomEndpoint(): string | undefined;
    set networkConnectivityCustomEndpoint(value: string | undefined);
    resetNetworkConnectivityCustomEndpoint(): void;
    get networkConnectivityCustomEndpointInput(): string | undefined;
    private _networkManagementCustomEndpoint?;
    get networkManagementCustomEndpoint(): string | undefined;
    set networkManagementCustomEndpoint(value: string | undefined);
    resetNetworkManagementCustomEndpoint(): void;
    get networkManagementCustomEndpointInput(): string | undefined;
    private _networkSecurityCustomEndpoint?;
    get networkSecurityCustomEndpoint(): string | undefined;
    set networkSecurityCustomEndpoint(value: string | undefined);
    resetNetworkSecurityCustomEndpoint(): void;
    get networkSecurityCustomEndpointInput(): string | undefined;
    private _networkServicesCustomEndpoint?;
    get networkServicesCustomEndpoint(): string | undefined;
    set networkServicesCustomEndpoint(value: string | undefined);
    resetNetworkServicesCustomEndpoint(): void;
    get networkServicesCustomEndpointInput(): string | undefined;
    private _notebooksCustomEndpoint?;
    get notebooksCustomEndpoint(): string | undefined;
    set notebooksCustomEndpoint(value: string | undefined);
    resetNotebooksCustomEndpoint(): void;
    get notebooksCustomEndpointInput(): string | undefined;
    private _orgPolicyCustomEndpoint?;
    get orgPolicyCustomEndpoint(): string | undefined;
    set orgPolicyCustomEndpoint(value: string | undefined);
    resetOrgPolicyCustomEndpoint(): void;
    get orgPolicyCustomEndpointInput(): string | undefined;
    private _osConfigCustomEndpoint?;
    get osConfigCustomEndpoint(): string | undefined;
    set osConfigCustomEndpoint(value: string | undefined);
    resetOsConfigCustomEndpoint(): void;
    get osConfigCustomEndpointInput(): string | undefined;
    private _osLoginCustomEndpoint?;
    get osLoginCustomEndpoint(): string | undefined;
    set osLoginCustomEndpoint(value: string | undefined);
    resetOsLoginCustomEndpoint(): void;
    get osLoginCustomEndpointInput(): string | undefined;
    private _privatecaCustomEndpoint?;
    get privatecaCustomEndpoint(): string | undefined;
    set privatecaCustomEndpoint(value: string | undefined);
    resetPrivatecaCustomEndpoint(): void;
    get privatecaCustomEndpointInput(): string | undefined;
    private _privilegedAccessManagerCustomEndpoint?;
    get privilegedAccessManagerCustomEndpoint(): string | undefined;
    set privilegedAccessManagerCustomEndpoint(value: string | undefined);
    resetPrivilegedAccessManagerCustomEndpoint(): void;
    get privilegedAccessManagerCustomEndpointInput(): string | undefined;
    private _project?;
    get project(): string | undefined;
    set project(value: string | undefined);
    resetProject(): void;
    get projectInput(): string | undefined;
    private _publicCaCustomEndpoint?;
    get publicCaCustomEndpoint(): string | undefined;
    set publicCaCustomEndpoint(value: string | undefined);
    resetPublicCaCustomEndpoint(): void;
    get publicCaCustomEndpointInput(): string | undefined;
    private _pubsubCustomEndpoint?;
    get pubsubCustomEndpoint(): string | undefined;
    set pubsubCustomEndpoint(value: string | undefined);
    resetPubsubCustomEndpoint(): void;
    get pubsubCustomEndpointInput(): string | undefined;
    private _pubsubLiteCustomEndpoint?;
    get pubsubLiteCustomEndpoint(): string | undefined;
    set pubsubLiteCustomEndpoint(value: string | undefined);
    resetPubsubLiteCustomEndpoint(): void;
    get pubsubLiteCustomEndpointInput(): string | undefined;
    private _recaptchaEnterpriseCustomEndpoint?;
    get recaptchaEnterpriseCustomEndpoint(): string | undefined;
    set recaptchaEnterpriseCustomEndpoint(value: string | undefined);
    resetRecaptchaEnterpriseCustomEndpoint(): void;
    get recaptchaEnterpriseCustomEndpointInput(): string | undefined;
    private _redisCustomEndpoint?;
    get redisCustomEndpoint(): string | undefined;
    set redisCustomEndpoint(value: string | undefined);
    resetRedisCustomEndpoint(): void;
    get redisCustomEndpointInput(): string | undefined;
    private _region?;
    get region(): string | undefined;
    set region(value: string | undefined);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _requestReason?;
    get requestReason(): string | undefined;
    set requestReason(value: string | undefined);
    resetRequestReason(): void;
    get requestReasonInput(): string | undefined;
    private _requestTimeout?;
    get requestTimeout(): string | undefined;
    set requestTimeout(value: string | undefined);
    resetRequestTimeout(): void;
    get requestTimeoutInput(): string | undefined;
    private _resourceManagerCustomEndpoint?;
    get resourceManagerCustomEndpoint(): string | undefined;
    set resourceManagerCustomEndpoint(value: string | undefined);
    resetResourceManagerCustomEndpoint(): void;
    get resourceManagerCustomEndpointInput(): string | undefined;
    private _resourceManagerV3CustomEndpoint?;
    get resourceManagerV3CustomEndpoint(): string | undefined;
    set resourceManagerV3CustomEndpoint(value: string | undefined);
    resetResourceManagerV3CustomEndpoint(): void;
    get resourceManagerV3CustomEndpointInput(): string | undefined;
    private _scopes?;
    get scopes(): string[] | undefined;
    set scopes(value: string[] | undefined);
    resetScopes(): void;
    get scopesInput(): string[] | undefined;
    private _secretManagerCustomEndpoint?;
    get secretManagerCustomEndpoint(): string | undefined;
    set secretManagerCustomEndpoint(value: string | undefined);
    resetSecretManagerCustomEndpoint(): void;
    get secretManagerCustomEndpointInput(): string | undefined;
    private _secureSourceManagerCustomEndpoint?;
    get secureSourceManagerCustomEndpoint(): string | undefined;
    set secureSourceManagerCustomEndpoint(value: string | undefined);
    resetSecureSourceManagerCustomEndpoint(): void;
    get secureSourceManagerCustomEndpointInput(): string | undefined;
    private _securityCenterCustomEndpoint?;
    get securityCenterCustomEndpoint(): string | undefined;
    set securityCenterCustomEndpoint(value: string | undefined);
    resetSecurityCenterCustomEndpoint(): void;
    get securityCenterCustomEndpointInput(): string | undefined;
    private _securityCenterManagementCustomEndpoint?;
    get securityCenterManagementCustomEndpoint(): string | undefined;
    set securityCenterManagementCustomEndpoint(value: string | undefined);
    resetSecurityCenterManagementCustomEndpoint(): void;
    get securityCenterManagementCustomEndpointInput(): string | undefined;
    private _securityCenterV2CustomEndpoint?;
    get securityCenterV2CustomEndpoint(): string | undefined;
    set securityCenterV2CustomEndpoint(value: string | undefined);
    resetSecurityCenterV2CustomEndpoint(): void;
    get securityCenterV2CustomEndpointInput(): string | undefined;
    private _securitypostureCustomEndpoint?;
    get securitypostureCustomEndpoint(): string | undefined;
    set securitypostureCustomEndpoint(value: string | undefined);
    resetSecuritypostureCustomEndpoint(): void;
    get securitypostureCustomEndpointInput(): string | undefined;
    private _serviceManagementCustomEndpoint?;
    get serviceManagementCustomEndpoint(): string | undefined;
    set serviceManagementCustomEndpoint(value: string | undefined);
    resetServiceManagementCustomEndpoint(): void;
    get serviceManagementCustomEndpointInput(): string | undefined;
    private _serviceNetworkingCustomEndpoint?;
    get serviceNetworkingCustomEndpoint(): string | undefined;
    set serviceNetworkingCustomEndpoint(value: string | undefined);
    resetServiceNetworkingCustomEndpoint(): void;
    get serviceNetworkingCustomEndpointInput(): string | undefined;
    private _serviceUsageCustomEndpoint?;
    get serviceUsageCustomEndpoint(): string | undefined;
    set serviceUsageCustomEndpoint(value: string | undefined);
    resetServiceUsageCustomEndpoint(): void;
    get serviceUsageCustomEndpointInput(): string | undefined;
    private _siteVerificationCustomEndpoint?;
    get siteVerificationCustomEndpoint(): string | undefined;
    set siteVerificationCustomEndpoint(value: string | undefined);
    resetSiteVerificationCustomEndpoint(): void;
    get siteVerificationCustomEndpointInput(): string | undefined;
    private _sourceRepoCustomEndpoint?;
    get sourceRepoCustomEndpoint(): string | undefined;
    set sourceRepoCustomEndpoint(value: string | undefined);
    resetSourceRepoCustomEndpoint(): void;
    get sourceRepoCustomEndpointInput(): string | undefined;
    private _spannerCustomEndpoint?;
    get spannerCustomEndpoint(): string | undefined;
    set spannerCustomEndpoint(value: string | undefined);
    resetSpannerCustomEndpoint(): void;
    get spannerCustomEndpointInput(): string | undefined;
    private _sqlCustomEndpoint?;
    get sqlCustomEndpoint(): string | undefined;
    set sqlCustomEndpoint(value: string | undefined);
    resetSqlCustomEndpoint(): void;
    get sqlCustomEndpointInput(): string | undefined;
    private _storageCustomEndpoint?;
    get storageCustomEndpoint(): string | undefined;
    set storageCustomEndpoint(value: string | undefined);
    resetStorageCustomEndpoint(): void;
    get storageCustomEndpointInput(): string | undefined;
    private _storageInsightsCustomEndpoint?;
    get storageInsightsCustomEndpoint(): string | undefined;
    set storageInsightsCustomEndpoint(value: string | undefined);
    resetStorageInsightsCustomEndpoint(): void;
    get storageInsightsCustomEndpointInput(): string | undefined;
    private _storageTransferCustomEndpoint?;
    get storageTransferCustomEndpoint(): string | undefined;
    set storageTransferCustomEndpoint(value: string | undefined);
    resetStorageTransferCustomEndpoint(): void;
    get storageTransferCustomEndpointInput(): string | undefined;
    private _tagsCustomEndpoint?;
    get tagsCustomEndpoint(): string | undefined;
    set tagsCustomEndpoint(value: string | undefined);
    resetTagsCustomEndpoint(): void;
    get tagsCustomEndpointInput(): string | undefined;
    private _tagsLocationCustomEndpoint?;
    get tagsLocationCustomEndpoint(): string | undefined;
    set tagsLocationCustomEndpoint(value: string | undefined);
    resetTagsLocationCustomEndpoint(): void;
    get tagsLocationCustomEndpointInput(): string | undefined;
    private _terraformAttributionLabelAdditionStrategy?;
    get terraformAttributionLabelAdditionStrategy(): string | undefined;
    set terraformAttributionLabelAdditionStrategy(value: string | undefined);
    resetTerraformAttributionLabelAdditionStrategy(): void;
    get terraformAttributionLabelAdditionStrategyInput(): string | undefined;
    private _tpuCustomEndpoint?;
    get tpuCustomEndpoint(): string | undefined;
    set tpuCustomEndpoint(value: string | undefined);
    resetTpuCustomEndpoint(): void;
    get tpuCustomEndpointInput(): string | undefined;
    private _universeDomain?;
    get universeDomain(): string | undefined;
    set universeDomain(value: string | undefined);
    resetUniverseDomain(): void;
    get universeDomainInput(): string | undefined;
    private _userProjectOverride?;
    get userProjectOverride(): boolean | cdktf.IResolvable | undefined;
    set userProjectOverride(value: boolean | cdktf.IResolvable | undefined);
    resetUserProjectOverride(): void;
    get userProjectOverrideInput(): boolean | cdktf.IResolvable | undefined;
    private _vertexAiCustomEndpoint?;
    get vertexAiCustomEndpoint(): string | undefined;
    set vertexAiCustomEndpoint(value: string | undefined);
    resetVertexAiCustomEndpoint(): void;
    get vertexAiCustomEndpointInput(): string | undefined;
    private _vmwareengineCustomEndpoint?;
    get vmwareengineCustomEndpoint(): string | undefined;
    set vmwareengineCustomEndpoint(value: string | undefined);
    resetVmwareengineCustomEndpoint(): void;
    get vmwareengineCustomEndpointInput(): string | undefined;
    private _vpcAccessCustomEndpoint?;
    get vpcAccessCustomEndpoint(): string | undefined;
    set vpcAccessCustomEndpoint(value: string | undefined);
    resetVpcAccessCustomEndpoint(): void;
    get vpcAccessCustomEndpointInput(): string | undefined;
    private _workbenchCustomEndpoint?;
    get workbenchCustomEndpoint(): string | undefined;
    set workbenchCustomEndpoint(value: string | undefined);
    resetWorkbenchCustomEndpoint(): void;
    get workbenchCustomEndpointInput(): string | undefined;
    private _workflowsCustomEndpoint?;
    get workflowsCustomEndpoint(): string | undefined;
    set workflowsCustomEndpoint(value: string | undefined);
    resetWorkflowsCustomEndpoint(): void;
    get workflowsCustomEndpointInput(): string | undefined;
    private _zone?;
    get zone(): string | undefined;
    set zone(value: string | undefined);
    resetZone(): void;
    get zoneInput(): string | undefined;
    private _alias?;
    get alias(): string | undefined;
    set alias(value: string | undefined);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    private _batching?;
    get batching(): GoogleProviderBatching | undefined;
    set batching(value: GoogleProviderBatching | undefined);
    resetBatching(): void;
    get batchingInput(): GoogleProviderBatching | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
