/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface StorageManagedFolderIamBindingConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#bucket StorageManagedFolderIamBinding#bucket}
    */
    readonly bucket: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#id StorageManagedFolderIamBinding#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#managed_folder StorageManagedFolderIamBinding#managed_folder}
    */
    readonly managedFolder: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#members StorageManagedFolderIamBinding#members}
    */
    readonly members: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#role StorageManagedFolderIamBinding#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#condition StorageManagedFolderIamBinding#condition}
    */
    readonly condition?: StorageManagedFolderIamBindingCondition;
}
export interface StorageManagedFolderIamBindingCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#description StorageManagedFolderIamBinding#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#expression StorageManagedFolderIamBinding#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#title StorageManagedFolderIamBinding#title}
    */
    readonly title: string;
}
export declare function storageManagedFolderIamBindingConditionToTerraform(struct?: StorageManagedFolderIamBindingConditionOutputReference | StorageManagedFolderIamBindingCondition): any;
export declare function storageManagedFolderIamBindingConditionToHclTerraform(struct?: StorageManagedFolderIamBindingConditionOutputReference | StorageManagedFolderIamBindingCondition): any;
export declare class StorageManagedFolderIamBindingConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): StorageManagedFolderIamBindingCondition | undefined;
    set internalValue(value: StorageManagedFolderIamBindingCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding google_storage_managed_folder_iam_binding}
*/
export declare class StorageManagedFolderIamBinding extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_storage_managed_folder_iam_binding";
    /**
    * Generates CDKTF code for importing a StorageManagedFolderIamBinding resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the StorageManagedFolderIamBinding to import
    * @param importFromId The id of the existing StorageManagedFolderIamBinding that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the StorageManagedFolderIamBinding to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_binding google_storage_managed_folder_iam_binding} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options StorageManagedFolderIamBindingConfig
    */
    constructor(scope: Construct, id: string, config: StorageManagedFolderIamBindingConfig);
    private _bucket?;
    get bucket(): string;
    set bucket(value: string);
    get bucketInput(): string | undefined;
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _managedFolder?;
    get managedFolder(): string;
    set managedFolder(value: string);
    get managedFolderInput(): string | undefined;
    private _members?;
    get members(): string[];
    set members(value: string[]);
    get membersInput(): string[] | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): StorageManagedFolderIamBindingConditionOutputReference;
    putCondition(value: StorageManagedFolderIamBindingCondition): void;
    resetCondition(): void;
    get conditionInput(): StorageManagedFolderIamBindingCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
