/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface StorageManagedFolderIamMemberConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#bucket StorageManagedFolderIamMember#bucket}
    */
    readonly bucket: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#id StorageManagedFolderIamMember#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#managed_folder StorageManagedFolderIamMember#managed_folder}
    */
    readonly managedFolder: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#member StorageManagedFolderIamMember#member}
    */
    readonly member: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#role StorageManagedFolderIamMember#role}
    */
    readonly role: string;
    /**
    * condition block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#condition StorageManagedFolderIamMember#condition}
    */
    readonly condition?: StorageManagedFolderIamMemberCondition;
}
export interface StorageManagedFolderIamMemberCondition {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#description StorageManagedFolderIamMember#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#expression StorageManagedFolderIamMember#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#title StorageManagedFolderIamMember#title}
    */
    readonly title: string;
}
export declare function storageManagedFolderIamMemberConditionToTerraform(struct?: StorageManagedFolderIamMemberConditionOutputReference | StorageManagedFolderIamMemberCondition): any;
export declare function storageManagedFolderIamMemberConditionToHclTerraform(struct?: StorageManagedFolderIamMemberConditionOutputReference | StorageManagedFolderIamMemberCondition): any;
export declare class StorageManagedFolderIamMemberConditionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): StorageManagedFolderIamMemberCondition | undefined;
    set internalValue(value: StorageManagedFolderIamMemberCondition | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member google_storage_managed_folder_iam_member}
*/
export declare class StorageManagedFolderIamMember extends cdktf.TerraformResource {
    static readonly tfResourceType = "google_storage_managed_folder_iam_member";
    /**
    * Generates CDKTF code for importing a StorageManagedFolderIamMember resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the StorageManagedFolderIamMember to import
    * @param importFromId The id of the existing StorageManagedFolderIamMember that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the StorageManagedFolderIamMember to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/google/6.2.0/docs/resources/storage_managed_folder_iam_member google_storage_managed_folder_iam_member} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options StorageManagedFolderIamMemberConfig
    */
    constructor(scope: Construct, id: string, config: StorageManagedFolderIamMemberConfig);
    private _bucket?;
    get bucket(): string;
    set bucket(value: string);
    get bucketInput(): string | undefined;
    get etag(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _managedFolder?;
    get managedFolder(): string;
    set managedFolder(value: string);
    get managedFolderInput(): string | undefined;
    private _member?;
    get member(): string;
    set member(value: string);
    get memberInput(): string | undefined;
    private _role?;
    get role(): string;
    set role(value: string);
    get roleInput(): string | undefined;
    private _condition;
    get condition(): StorageManagedFolderIamMemberConditionOutputReference;
    putCondition(value: StorageManagedFolderIamMemberCondition): void;
    resetCondition(): void;
    get conditionInput(): StorageManagedFolderIamMemberCondition | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
